SystemOrganization addCategory: #'LeapMotion-FFI'!
SystemOrganization addCategory: #'LeapMotion-Etoys'!
SystemOrganization addCategory: #'LeapMotion-Core'!

Morph subclass: #LeapFingerMorph
	instanceVariableNames: 'finger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapFingerMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 6/13/2014 10:02'!
additionsToViewerCategories


^ #(

(#'general' (


#(slot fingerId 'Shows the id of this finger' Number readOnly Player getFingerId Player unused )
#(slot isFinger 'Shows if this is a finger' Boolean readOnly Player getIsFinger Player unused )
#(slot isTool 'Show if this is a tool' Boolean readOnly Player getIsTool Player unused )
#(slot fingerLength 'Shows the length of this object' Number readOnly Player getFingerLength Player unused )
#(slot fingerWidth 'Shows the width of the finger' Number readOnly Player getFingerWidth Player unused )
#(slot tipPositionX 'Shows the x position of the finger tip' Number readOnly Player getTipPositionX Player unused )
#(slot tipPositionY 'Shows the y position of the finger tip' Number readOnly Player getTipPositionY Player unused )
#(slot tipPositionZ 'Shows the z position of the finger tip' Number readOnly Player getTipPositionZ Player unused )
#(slot touchZone 'Shows the touch zone value of the finger tip' Number readOnly Player getTouchZone Player unused )


))


)! !

!LeapFingerMorph methodsFor: 'drawing' stamp: 'sgb 6/16/2014 16:23'!
drawOn: aCanvas
	aCanvas fillOval: bounds color: self color! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:18'!
finger
	^ finger! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:18'!
fingerId
	^ finger id! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:18'!
fingerLength
	^ finger length! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:18'!
fingerWidth
	^ finger width! !

!LeapFingerMorph methodsFor: 'initializing' stamp: 'sgb 6/16/2014 18:18'!
initialize
	super initialize.
	self color: Color blue;
		extent: 20@20
	! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:18'!
isFinger
	^ finger isFinger! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:21'!
isTool
	^ finger isTool! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:19'!
newPlayerInstance
	^ LeapFingerPlayer newUserInstance! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:19'!
tipPositionX
	^ finger tipPosition x! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:19'!
tipPositionY
	^ finger tipPosition y! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:19'!
tipPositionZ
	^ finger tipPosition z! !

!LeapFingerMorph methodsFor: 'accesing' stamp: 'sgb 6/16/2014 18:19'!
touchZone
	^ finger touchZone! !

!LeapFingerMorph methodsFor: 'updating ui' stamp: 'sgb 6/17/2014 18:22'!
updateFinger: aFinger interactionBox: anInteractionBox 
	finger := aFinger.
	self updatePositionRelativeTo: anInteractionBox! !

!LeapFingerMorph methodsFor: 'updating ui' stamp: 'sgb 6/17/2014 18:26'!
updatePositionRelativeTo: ib
	| pos xAxis yAxis |
	pos := finger tipPosition.
	xAxis := [:x || m b | 
		m := owner owner width / ib width.
		b := m * ib left * -1.
		m * x + b].
	yAxis := [:x || m b |
		m := owner owner height / (ib bottom - ib top).
		b := m * ib bottom * -1.
		m * x + b].	
	self center: owner owner center +
		((xAxis value: pos x) @ (yAxis value: pos y - ib center y)).! !

Morph subclass: #LeapHandMorph
	instanceVariableNames: 'hand fingers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapHandMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 6/12/2014 00:09'!
additionsToViewerCategories


^ #(

(#'general' (

#(slot #id 'Shows the id of this hand' Number readOnly Player getId Player unused )
#(slot #isValid 'Shows if this hand is valid' Boolean readOnly Player getIsValid Player unused )
#(slot #sphereRadius 'Shows the sphere radius of this hand' Number readOnly Player getSphereRadius Player unused )

))

(#'orientation' (

#(slot #pitch 'Shows the pitch value of this hand' Number readOnly Player getHandPitch Player unused )
#(slot #roll 'Shows the roll value of this hand' Number readOnly Player getRoll Player unused )
#(slot #yaw 'Shows the yaw value of  this hand' Number readOnly Player getYaw Player unused )



))


(#'positions' (


#(slot #palmPositionX 'Shows the x value of the position of this hand' Number readOnly Player getPalmPositionX Player unused )
#(slot #palmPositionY 'Shows the y value of the position of this hand' Number readOnly Player getPalmPositionY Player unused )
#(slot #palmPositionZ 'Shows the z value of the position of this hand' Number readOnly Player getPalmPositionZ Player unused )

#(slot #sphereCenterX 'Shows the x value of the position of the sphere center of this hand' Number readOnly Player getSphereCenterX Player unused )
#(slot #sphereCenterY 'Shows the y value of the position of the sphere center of this hand' Number readOnly Player getSphereCenterY Player unused )
#(slot #sphereCenterZ 'Shows the z value of the position of the sphere center of this hand' Number readOnly Player getSphereCenterZ Player unused )




))



)! !

!LeapHandMorph methodsFor: 'updating ui' stamp: 'sgb 6/16/2014 16:21'!
drawOn: aCanvas
	aCanvas fillOval: bounds color: self color! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:22'!
hand
	^ hand! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:22'!
handPitch
	(hand isValid)
		ifTrue: [^ hand pitch]
		ifFalse: [^0]! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:22'!
id
	^ hand id ! !

!LeapHandMorph methodsFor: 'initializing' stamp: 'sgb 6/17/2014 14:42'!
initialize
	super initialize.
	self color: Color green;
		extent: 50@50.
	self initializeFingers.! !

!LeapHandMorph methodsFor: 'initializing' stamp: 'sgb 6/16/2014 16:33'!
initializeFingers
	fingers := (1 to: 5) collect: [:ign | LeapFingerMorph new].
	fingers do: [:f | self addMorph: f].
	fingers with: {41@ -85. 4@ -94 . -32@ -73. 93@ -12. -54@ -45}
		do: [:m :p | m center: self center + p]
	! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
isValid
	^ hand isValid! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/12/2014 00:03'!
newPlayerInstance
	^ LeapHandPlayer newUserInstance! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
palmPositionX
	^ hand palmPosition x ! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
palmPositionY
	^ hand palmPosition y! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
palmPositionZ
	^ hand palmPosition z! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
roll
	(hand isValid)
			ifTrue: [^ hand roll]
			ifFalse: [^0]! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
setInitialPosition
	self position: owner position + (60@117).! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
sphereCenterX
	^ hand sphereCenter x! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
sphereCenterY
	^ hand sphereCenter y! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:23'!
sphereCenterZ
	^ hand sphereCenter z! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:24'!
sphereRadius
	^ hand sphereRadius! !

!LeapHandMorph methodsFor: 'updating ui' stamp: 'sgb 6/16/2014 16:57'!
updateHand: aHand interactionBox: anInteractionBox 
	hand := aHand.
	fingers 
		with: aHand fingers 
		do: [:fingerMorph :finger |
			fingerMorph 
				updateFinger: finger
				interactionBox: anInteractionBox].
	self updatePositionRelativeTo: anInteractionBox
! !

!LeapHandMorph methodsFor: 'updating ui' stamp: 'sgb 6/17/2014 18:26'!
updatePositionRelativeTo: ib
	| pos xAxis yAxis |
	hand isValid ifFalse: [self setInitialPosition. ^ self].
	pos := hand palmPosition.
	xAxis := [:x || m b | 
		m := owner width / ib width.
		b := m * ib left * -1.
		m * x + b].
	yAxis := [:x || m b |
		m := owner height / (ib bottom - ib top).
		b := m * ib bottom * -1.
		m * x + b].	
	self center: owner center +
		((xAxis value: pos x) @ (yAxis value: pos y - ib center y)).! !

!LeapHandMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:35'!
yaw
	(hand isValid)
		ifTrue: [^ hand yaw]
		ifFalse: [^0]! !

Morph subclass: #LeapMorph
	instanceVariableNames: 'leap hands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 6/12/2014 00:13'!
additionsToViewerCategories

^ #(

(#'leap connection' (

#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot IsConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )

))

(#'frame' (

#(slot currentFramesPerSecond 'Shows the FPS' Number readOnly Player getCurrentFramesPerSecond Player unused )
#(slot handsCount 'Shows the number of hands detected' Number readOnly Player getHandsCount Player unused )
#(slot fingersCount 'Shows the number of fingers detected' Number readOnly Player getFingersCount Player unused )
#(slot toolsCount 'Shows the number of tools detected' Number readOnly Player getToolsCount Player unused )
#(slot gesturesCount 'Shows the number of gestures detected' Number readOnly Player getGesturesCount Player unused )

))


(#'interaction box' (

#(slot IbDepth 'Shows the depth of the interaction box' Number readOnly Player getIbDepth Player unused )
#(slot IbHeight 'Shows the height of the interaction box' Number readOnly Player getIbHeight Player unused )
#(slot IbWidth 'Shows the width of the interaction box' Number readOnly Player getIbWidth Player unused )



))


)! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
connect
	leap connect.

! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
currentFramesPerSecond
	^ leap  frame currentFramesPerSecond! !

!LeapMorph methodsFor: 'halo' stamp: 'sgb 6/16/2014 18:24'!
defersHaloToInterior
	^ true! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:37'!
depth
	^ leap frame ib depth! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
disconnect
	leap disconnect.! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
fingersCount
	^ leap frame fingersCount! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:37'!
gesturesCount
	^ leap frame  gesturesCount! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
handsCount
	^ leap frame  handsCount! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
height
	^ leap frame ib height! !

!LeapMorph methodsFor: 'initializing' stamp: 'sgb 6/17/2014 14:17'!
initialize
	super initialize.
	self color: Color white;
		clipSubmorphs: true;
		extent: 400 @ 200.
	
	leap := LeapMotion  new.
	
	self initializeHands.
! !

!LeapMorph methodsFor: 'initializing' stamp: 'sgb 6/17/2014 14:16'!
initializeHands
	hands := (1 to: 4) collect: [:ign | LeapHandMorph new].
	hands do: [:h | self addMorph: h].! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
isConnected 
	^ leap  isConnected ! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/12/2014 00:02'!
newPlayerInstance
	^ LeapPlayer newUserInstance! !

!LeapMorph methodsFor: 'stepping' stamp: 'sgb 6/17/2014 18:20'!
step
	| frame |
	
	frame := leap frame.
	"
	1 to: 4 do: [:i || e1 e2 |
	e1 := hands at: i. 
	e2 := frame hands at: i.
	e1 updateHand: e2 interactionBox: frame ib  
	].
	 "
	hands with: frame hands do: [ :e1 :e2 | e1 updateHand: e2 interactionBox: frame ib].
	
	
	




! !

!LeapMorph methodsFor: 'stepping' stamp: 'sgb 6/16/2014 18:25'!
stepTime
	^ 1! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
toolsCount
	^ leap frame toolsCount! !

!LeapMorph methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:36'!
width
	^ leap frame ib width! !

Object subclass: #LeapMotion
	instanceVariableNames: 'isConnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Core'!

!LeapMotion methodsFor: 'connection' stamp: 'sgb 6/16/2014 18:26'!
connect
	self isConnected ifTrue: [^ self].
	LeapMotionApi apiCreate.
	isConnected:=true.
	LeapMotionApi apiEnableAllGestures.
! !

!LeapMotion methodsFor: 'connection' stamp: 'sgb 6/9/2014 12:10'!
disconnect

self isConnected ifFalse: [^ self].
isConnected:=false.
LeapMotionApi apiDestroy.
! !

!LeapMotion methodsFor: 'data adquisition' stamp: 'sgb 6/16/2014 18:26'!
frame
 	^ self isConnected
		ifTrue: [LeapMotionApi apiGetFrameGeneralData]
		ifFalse: [LeapFrame nil]! !

!LeapMotion methodsFor: 'initialization' stamp: 'sgb 6/16/2014 18:26'!
initialize 
	isConnected :=false.

! !

!LeapMotion methodsFor: 'connection' stamp: 'sgb 6/16/2014 18:26'!
isConnected
	^ isConnected 

! !

Object subclass: #LeapMotionApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'Richo 5/6/2014 19:38'!
apiCreate
	<apicall: long 'create' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'Richo 5/6/2014 19:38'!
apiDestroy
	<apicall: long 'destroy' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'sgb 6/4/2014 19:04'!
apiDisableAllGestures
	<apicall: long 'disableAllGestures' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'sgb 6/4/2014 19:03'!
apiEnableAllGestures
	<apicall: long 'enableAllGestures' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'Richo 5/6/2014 19:38'!
apiFoo
	<apicall: long 'foo' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'sgb 6/4/2014 19:00'!
apiGetFrameGeneralData 
	<apicall: LeapFrame 'getFrameGeneralData' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

!LeapMotionApi class methodsFor: 'as yet unclassified' stamp: 'sgb 5/8/2014 17:57'!
apiPruebaFingers
	<apicall: long 'pruebaFingers' () module: 'Prueba2.dll'>
	^ self externalCallFailed! !

ExternalStructure subclass: #Finger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

!Finger class methodsFor: 'as yet unclassified' stamp: 'sgb 6/5/2014 17:19'!
fields
"
	self defineFields.
"
	^ #(
	(width 'float')
	(length 'float')
	(touchDistance 'float')
	(isFinger 'long')	
	(isTool 'long')	
	(id 'long')	
	(direction 'Vector3')	
	(tipPosition 'Vector3')	
	(touchZone 'long')	
	)! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:27'!
direction
	"This method was automatically generated"
	^Vector3 fromHandle: (handle structAt: 25 length: 16)! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:27'!
id
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
isFinger
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
isTool
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
length
	"This method was automatically generated"
	^handle floatAt: 5! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
tipPosition
	"This method was automatically generated"
	^Vector3 fromHandle: (handle structAt: 41 length: 16)! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
touchDistance
	"This method was automatically generated"
	^handle floatAt: 9! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
touchZone
	"This method was automatically generated"
	^handle signedLongAt: 57! !

!Finger methodsFor: 'accessing' stamp: 'sgb 6/5/2014 17:19'!
width
	"This method was automatically generated"
	^handle floatAt: 1! !

ExternalStructure subclass: #Hand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

!Hand class methodsFor: 'as yet unclassified' stamp: 'sgb 6/9/2014 16:50'!
fields
"
	self defineFields.
"
	^ #(
	(sphereRadius 'float')
	(id 'long') 
	(isValidN 'long') 
	(pitch 'float')
	(yaw 'float')	
	(roll 'float')	
	(sphereCenter 'Vector3')
	(palmPosition 'Vector3')	
	(finger1 'Finger')
	(finger2 'Finger')
	(finger3 'Finger')
	(finger4 'Finger')
	(finger5 'Finger')
	)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
finger1
	"This method was automatically generated"
	^Finger fromHandle: (handle structAt: 57 length: 60)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
finger2
	"This method was automatically generated"
	^Finger fromHandle: (handle structAt: 117 length: 60)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
finger3
	"This method was automatically generated"
	^Finger fromHandle: (handle structAt: 177 length: 60)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
finger4
	"This method was automatically generated"
	^Finger fromHandle: (handle structAt: 237 length: 60)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
finger5
	"This method was automatically generated"
	^Finger fromHandle: (handle structAt: 297 length: 60)! !

!Hand methodsFor: 'accessing' stamp: 'sgb 6/16/2014 16:31'!
fingers
	^ {self finger1.
		self finger2.
		self finger3.
		self finger4.
		self finger5}! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
id
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!Hand methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
isValid
	^ self isValidN ~= 0! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
isValidN
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
palmPosition
	"This method was automatically generated"
	^Vector3 fromHandle: (handle structAt: 41 length: 16)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
pitch
	"This method was automatically generated"
	^handle floatAt: 13! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
roll
	"This method was automatically generated"
	^handle floatAt: 21! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
sphereCenter
	"This method was automatically generated"
	^Vector3 fromHandle: (handle structAt: 25 length: 16)! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
sphereRadius
	"This method was automatically generated"
	^handle floatAt: 1! !

!Hand methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/9/2014 16:50'!
yaw
	"This method was automatically generated"
	^handle floatAt: 17! !

ExternalStructure subclass: #InteractionBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

!InteractionBox class methodsFor: 'as yet unclassified' stamp: 'sgb 6/5/2014 17:14'!
fields
"
	self defineFields.
"
	^ #(
	(center 'Vector3')
	(depth 'float')
	(height 'float')
	(width 'float')	
	)! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 17:35'!
bottom
	^ self center y - (self height / 2)! !

!InteractionBox methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/5/2014 17:14'!
center
	"This method was automatically generated"
	^Vector3 fromHandle: (handle structAt: 1 length: 16)! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:05'!
corner
	^ self right @ self top! !

!InteractionBox methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/5/2014 17:14'!
depth
	"This method was automatically generated"
	^handle floatAt: 17! !

!InteractionBox methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/5/2014 17:14'!
height
	"This method was automatically generated"
	^handle floatAt: 21! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 17:01'!
left
	^ self center x - (self width / 2)! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 18:05'!
origin
	^ self left @ self bottom! !

!InteractionBox methodsFor: 'printing' stamp: 'sgb 6/16/2014 18:05'!
printOn: aStream
	aStream nextPut: $(.
	self origin printOn: aStream.
	aStream nextPutAll: ' corner: '.
	self corner printOn: aStream.
	aStream nextPut: $)! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 17:02'!
right
	^ self center x + (self width / 2)! !

!InteractionBox methodsFor: 'accessing' stamp: 'sgb 6/16/2014 17:35'!
top
	^ self center y + (self height / 2)! !

!InteractionBox methodsFor: 'accessing-autogenerated' stamp: 'sgb 6/5/2014 17:14'!
width
	"This method was automatically generated"
	^handle floatAt: 25! !

ExternalStructure subclass: #LeapFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

LeapFrame class
	instanceVariableNames: 'nilInstance'!

LeapFrame class
	instanceVariableNames: 'nilInstance'!

!LeapFrame class methodsFor: 'as yet unclassified' stamp: 'sgb 6/5/2014 17:22'!
fields
"
	self defineFields.
"
	^ #(
	(currentFramesPerSecond 'float')
	(handsCount 'long')
	(fingersCount 'long')
	(toolsCount 'long')
	(gesturesCount 'long')
	(ib 'InteractionBox')
	(hand1 'Hand')
	(hand2 'Hand')
	(hand3 'Hand')
	(hand4 'Hand')
	
	)! !

!LeapFrame class methodsFor: 'as yet unclassified' stamp: 'sgb 6/9/2014 15:24'!
nil
	^ nilInstance ifNil: [nilInstance := self new]! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
currentFramesPerSecond
	"This method was automatically generated"
	^handle floatAt: 1! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
fingersCount
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
gesturesCount
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
hand1
	"This method was automatically generated"
	^Hand fromHandle: (handle structAt: 49 length: 356)! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
hand2
	"This method was automatically generated"
	^Hand fromHandle: (handle structAt: 405 length: 356)! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
hand3
	"This method was automatically generated"
	^Hand fromHandle: (handle structAt: 761 length: 356)! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
hand4
	"This method was automatically generated"
	^Hand fromHandle: (handle structAt: 1117 length: 356)! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/17/2014 14:13'!
hands
	^ {self hand1.
		self hand2.
		self hand3.
		self hand4}
		
		! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
handsCount
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
ib
	"This method was automatically generated"
	^InteractionBox fromHandle: (handle structAt: 21 length: 28)! !

!LeapFrame methodsFor: 'accessing' stamp: 'sgb 6/9/2014 16:51'!
toolsCount
	"This method was automatically generated"
	^handle signedLongAt: 13! !

ExternalStructure subclass: #Vector3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-FFI'!

!Vector3 class methodsFor: 'as yet unclassified' stamp: 'sgb 6/4/2014 18:46'!
fields
"
	self defineFields.
"
	^ #(
	(x 'float')
	(y 'float')
	(z 'float')
	(magnitude 'float')	
	)! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
magnitude
	"This method was automatically generated"
	^handle floatAt: 13! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
magnitude: anObject
	"This method was automatically generated"
	handle floatAt: 13 put: anObject! !

!Vector3 methodsFor: 'printing' stamp: 'sgb 6/4/2014 19:47'!
printOn: aStream	
	self x rounded printOn: aStream.
	aStream nextPut: $@.
	self y rounded printOn: aStream.
	aStream nextPut: $@.
	self z rounded printOn: aStream! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
x
	"This method was automatically generated"
	^handle floatAt: 1! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
x: anObject
	"This method was automatically generated"
	handle floatAt: 1 put: anObject! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
y
	"This method was automatically generated"
	^handle floatAt: 5! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
y: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
z
	"This method was automatically generated"
	^handle floatAt: 9! !

!Vector3 methodsFor: 'accessing' stamp: 'sgb 6/4/2014 19:41'!
z: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

Player subclass: #LeapFingerPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:20'!
getFingerId
	^ self sendMessageToCostume: #fingerId! !

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:20'!
getFingerLength
	^ self sendMessageToCostume: #fingerLength! !

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:20'!
getFingerWidth
	^ self sendMessageToCostume: #fingerWidth! !

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:21'!
getIsFinger
	^ self sendMessageToCostume: #isFinger! !

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:20'!
getIsTool
	^ self sendMessageToCostume: #isTool! !

!LeapFingerPlayer methodsFor: 'tip position' stamp: 'sgb 6/16/2014 18:20'!
getTipPositionX
	^ self sendMessageToCostume: #tipPositionX! !

!LeapFingerPlayer methodsFor: 'tip position' stamp: 'sgb 6/16/2014 18:20'!
getTipPositionY
	^ self sendMessageToCostume: #tipPositionY! !

!LeapFingerPlayer methodsFor: 'tip position' stamp: 'sgb 6/16/2014 18:21'!
getTipPositionZ
	^ self sendMessageToCostume: #tipPositionZ! !

!LeapFingerPlayer methodsFor: 'general data' stamp: 'sgb 6/16/2014 18:21'!
getTouchZone
	^ self sendMessageToCostume: #touchZone! !

Player subclass: #LeapHandPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapHandPlayer methodsFor: 'orientation' stamp: 'sgb 6/12/2014 00:00'!
getHandPitch
	^ self sendMessageToCostume: #handPitch! !

!LeapHandPlayer methodsFor: 'general' stamp: 'sgb 6/11/2014 23:50'!
getId
	^ self sendMessageToCostume: #id! !

!LeapHandPlayer methodsFor: 'general' stamp: 'sgb 6/11/2014 23:50'!
getIsValid
	^ self sendMessageToCostume: #isValid! !

!LeapHandPlayer methodsFor: 'positions' stamp: 'sgb 6/11/2014 23:51'!
getPalmPositionX
	^ self sendMessageToCostume: #palmPositionX! !

!LeapHandPlayer methodsFor: 'positions' stamp: 'sgb 6/11/2014 23:51'!
getPalmPositionY
	^ self sendMessageToCostume: #palmPositionY! !

!LeapHandPlayer methodsFor: 'positions' stamp: 'sgb 6/11/2014 23:51'!
getPalmPositionZ
	^ self sendMessageToCostume: #palmPositionZ! !

!LeapHandPlayer methodsFor: 'orientation' stamp: 'sgb 6/11/2014 23:50'!
getRoll
	^ self sendMessageToCostume: #roll! !

!LeapHandPlayer methodsFor: 'sphere' stamp: 'sgb 6/11/2014 23:51'!
getSphereCenterX
	^ self sendMessageToCostume: #sphereCenterX! !

!LeapHandPlayer methodsFor: 'sphere' stamp: 'sgb 6/11/2014 23:52'!
getSphereCenterY
	^ self sendMessageToCostume: #sphereCenterY! !

!LeapHandPlayer methodsFor: 'sphere' stamp: 'sgb 6/11/2014 23:52'!
getSphereCenterZ
	^ self sendMessageToCostume: #sphereCenterZ! !

!LeapHandPlayer methodsFor: 'sphere' stamp: 'sgb 6/11/2014 23:51'!
getSphereRadius
	^ self sendMessageToCostume: #sphereRadius! !

!LeapHandPlayer methodsFor: 'orientation' stamp: 'sgb 6/11/2014 23:50'!
getYaw
	^ self sendMessageToCostume: #yaw! !

Player subclass: #LeapPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LeapMotion-Etoys'!

!LeapPlayer methodsFor: 'connecting' stamp: 'sgb 6/9/2014 15:07'!
connect
	^ self sendMessageToCostume: #connect! !

!LeapPlayer methodsFor: 'connecting' stamp: 'sgb 6/9/2014 15:07'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!LeapPlayer methodsFor: 'frame data' stamp: 'sgb 6/11/2014 01:00'!
getCurrentFramesPerSecond
	^ self sendMessageToCostume: #currentFramesPerSecond! !

!LeapPlayer methodsFor: 'frame data' stamp: 'sgb 6/11/2014 01:01'!
getFingersCount
	^ self sendMessageToCostume: #fingersCount! !

!LeapPlayer methodsFor: 'frame data' stamp: 'sgb 6/11/2014 01:01'!
getGesturesCount
	^ self sendMessageToCostume: #gesturesCount! !

!LeapPlayer methodsFor: 'frame data' stamp: 'sgb 6/11/2014 01:01'!
getHandsCount
	^ self sendMessageToCostume: #handsCount! !

!LeapPlayer methodsFor: 'interaction box' stamp: 'sgb 6/11/2014 14:40'!
getIbDepth
	^ self sendMessageToCostume: #depth! !

!LeapPlayer methodsFor: 'interaction box' stamp: 'sgb 6/11/2014 14:40'!
getIbHeight
	^ self sendMessageToCostume: #height! !

!LeapPlayer methodsFor: 'interaction box' stamp: 'sgb 6/11/2014 14:39'!
getIbWidth
	^ self sendMessageToCostume: #width! !

!LeapPlayer methodsFor: 'connecting' stamp: 'sgb 6/9/2014 15:20'!
getIsConnected
	^ self sendMessageToCostume: #isConnected! !

!LeapPlayer methodsFor: 'frame data' stamp: 'sgb 6/11/2014 01:01'!
getToolsCount
	^ self sendMessageToCostume: #toolsCount! !
